;---------------------------------------------------------------------------------
;| Duotos dvi simboliu eilutes. Parasyti programa, kuri i rezultato eilute iraso |
;| tik tuos simbolius, kurie yra tiek pirmoje, tiek antroje eiluteje.            |
;| Pvz., eilutems asdffg llfkkeir ir ooprooi ertterase turi atspausdinti aseir.  |
;---------------------------------------------------------------------------------

.model small 				 ;programai reikia nedaug atminties

.stack 100h					 ;steko segmentas

.data 						 ;duomenu segmentas

inputstr1 db 100 dup (?),'$' ;pirma ivedimo eilute, nuskaitoma is klaviaturos 
inputstr2 db 100 dup (?),'$' ;antra ivedimo eilute, nuskaitoma is klaviaturos 

pran1     db  13,10,'Iveskite simboliu eilute:',13,10,'$'		 ;pirmas pranesimas
pran2     db  13,10,'Iveskite kita simboliu eilute:',13,10,'$'	 ;antras pranesimas		
pran3 	  db  13,10,'Rezultatas:',13,10,'$'						 ;trecias pranesimas
pran4     db  'Neivedete eilutes!',13,10,'$'				     ;ketvirtas pranesimas
pran5 	  db  13,10,'Eilutese nebuvo pasikartojanciu simboliu.',13,10,'$' ;penktas pranesimas

.code 						 ;kodo segmentas

		  mov ax, @data      ;i registra ax irasomas paragrafo, kuriame prasideda duomenu segmentas, numeris
		  mov ds, ax		 ;nukopijuojamas registras ax i duomenu segmento registra ds
    
		  jmp pradzia		 ;nusokama i pradzia
			
;---------------------- Eilutes nuskaitymas ------------------------------------------------------------------------------

readln    macro eil          ;apibreziamas konstruktorius
          mov bx, 0          ;nurodo standartini ivedimo buferio handleri
          mov ah, 3fh        ;nuskaitoma eilute
          mov dx, offset eil ;uzkraunamas ivedamu duomenu buferio adresas     
          int 21h            ;pertraukimas
          sub al, 2			 ;is ilgio atimami 2
          endm               ;konstruktoriaus pabaiga    

;---------------------- Eilutes spausdinimas -----------------------------------------------------------------------------
 
write     macro eil			 ;apibreziamas konstruktoriuas
          mov ah, 9h		 ;spausdinama eilute
          mov dx, offset eil ;uzkraunamas duomenu buferio adresas
          int 21h            ;pertraukimas   
          endm				 ;konstruktoriaus pabaiga
          
;-------------------------------------------------------------------------------------------------------------------------

pradzia:  write pran1 		 ;spausdinamas pirmas pranesimas
		  readln inputstr1	 ;nuskaitoma pirma eilute
		  
		  cmp al, 0			 ;tikrinama, ar eilute ne tuscia
		  je oi				 ;jei tuscia, nusokama i oi
		  
pr:		  write pran2		 ;spausdinamas antras pranesimas
          readln inputstr2   ;nuskaitoma antra eilute
          
          cmp al, 0			 ;tikrinama, ar eilute ne tuscia
		  je oi2			 ;jei tuscia, nusokama i oi2
    
		  write pran3		 ;spausdinamas trecias pranesimas
		  
		  mov di, offset inputstr1 ;pirma eilute priskiriama indeksui di
		  
		  mov cl, 0 	     ;inicijuojamas skaitliukas cl (priskiriamas 0)
	  
		  jmp L1			 ;nusokama i L1

;-------------------------------------------------------------------------------------------------------------------------		  
		  		  
oi:  	  write pran4	     ;spausdinamas ketvirtas pranesimas
		  jmp pradzia		 ;nusokama i pradzia
		  
;-------------------------------------------------------------------------------------------------------------------------
  
oi2:	  write pran4		 ;spausdinamas ketvirtas pranesimas
		  jmp pr			 ;nusokama i pr
		  
;-------------------------------------------------------------------------------------------------------------------------
  
L1: 	  mov al, [di]	 	 ;paimamas simbolis is pirmos eilutes
		  cmp al, '$' 		 ;tikrinama, ar simbolis sutampa su eilutes pabaigos simboliu (ar jau eilutes pabaiga)
		  je ziurom 		 ;jei taip, nusokama i ziurom
    
		  mov si, offset inputstr2 ;antra eilute priskiriama indeksui si
    
		  jmp E2		     ;nusokama i E2 (tikrinsim antra eilute)

;-------------------------------------------------------------------------------------------------------------------------  
  
E2:		  mov ah, [si]		 ;paimamas simbolis is antros eilutes
		  cmp ah, '$'		 ;tikrinama, ar simbolis sutampa su eilutes pabaigos simboliu (ar jau eilutes pabaiga)
		  je E1 			 ;jei taip, nusokama i E1
		
		  cmp al,ah          ;lyginami paimti pirmos ir antros eilutes simboliai
		  je L2 			 ;jei jie lygus, nusokama i L2
    
		  inc si     		 ;antros eilutes indeksas padidinamas vienetu
    
		  jmp E2 			 ;nusokama i E2 (tam, kad perbegtume visa antraja eilute)
	
;-------------------------------------------------------------------------------------------------------------------------
    
E1:		  inc di 			 ;pirmos eilutes indeksas padidinamas vienetu
	
		  jmp L1 			 ;nusokama i L1
		  
;------------------------------------------------------------------------------------------------------------------------- 
		  
L2:    	  cmp al, ' '		 ;lyginama, ar simbolis yra tarpas
		  jne L3 			 ;jei nera, nusokama i L3, kur jis bus atspausdintas
		  
		  inc si 			 ;antros eilutes indeksas padidinamas vienetu
		  
		  jmp E2			 ;nusokama i E2
  
;-------------------------------------------------------------------------------------------------------------------------

L3:  	  push ax            ;padedamas registras ax i steka
		  mov ah, 0Eh        ;spausdinamas simbolis
	      int 10h            ;pertraukimas
          pop ax    		 ;grazinamas registras ax is steko
            
		  inc di 			 ;pirmos eilutes indeksas padidinamas vienetu
		  inc cl		     ;skaitliukas cl padidinamas 1
		  
		  jmp L1 			 ;nusokama i L1
		  
;-------------------------------------------------------------------------------------------------------------------------

ziurom:	  cmp cl, 1
		  je nera
		  jmp pabaiga
		  
;-------------------------------------------------------------------------------------------------------------------------
		  
nera: 	  write pran5

;-------------------------------------------------------------------------------------------------------------------------		  

pabaiga:  mov ah, 4Ch        ;valdymas perduodamas operacinei sistemai
		  int 21h			 ;pertraukimas
		  	  
end 